/// <reference types="node" />
import { ServerResponse, IncomingMessage } from "http";
import { Http2ServerRequest, Http2ServerResponse } from "http2";
import { Function1, SideEffect2 } from "@reactive-js/core/lib/functions";
import { IOSourceLike } from "@reactive-js/core/lib/io";
import { ObservableLike } from "@reactive-js/core/lib/observable";
import { SchedulerLike } from "@reactive-js/core/lib/scheduler";
import { HttpResponse, HttpServerRequest, HttpServer } from "../../http";
export declare type HttpRequestListenerOptions = {
    readonly onError?: Function1<unknown, void | ObservableLike<unknown>>;
};
export declare type HttpRequestListener = SideEffect2<IncomingMessage | Http2ServerRequest, ServerResponse | Http2ServerResponse>;
export declare const createHttpRequestListener: (handler: HttpServer<HttpServerRequest<IOSourceLike<Uint8Array>>, HttpResponse<IOSourceLike<Uint8Array>>>, scheduler: SchedulerLike, options?: HttpRequestListenerOptions) => SideEffect2<IncomingMessage | Http2ServerRequest, ServerResponse | Http2ServerResponse>;
