"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const io_1 = require("@reactive-js/core/lib/io");
const option_1 = require("@reactive-js/core/lib/option");
const cacheDirective_1 = require("./cacheDirective");
const httpContentInfo_1 = require("./httpContentInfo");
const httpHeaders_1 = require("./httpHeaders");
const httpPreferences_1 = require("./httpPreferences");
exports.writeHttpMessageHeaders = ({ cacheControl, contentInfo, headers, preferences }, writeHeader) => {
    cacheDirective_1.writeHttpCacheControlHeader(cacheControl, writeHeader);
    if (option_1.isSome(contentInfo)) {
        httpContentInfo_1.writeHttpContentInfoHeaders(contentInfo, writeHeader);
    }
    if (option_1.isSome(preferences)) {
        httpPreferences_1.writeHttpPreferenceHeaders(preferences, writeHeader);
    }
    httpHeaders_1.writeHttpHeaders(headers, writeHeader);
};
exports.encodeHttpMessageWithUtf8 = (_a) => {
    var { contentInfo } = _a, msg = __rest(_a, ["contentInfo"]);
    if (option_1.isNone(contentInfo)) {
        throw new Error("HttpMessage has not contentInfo");
    }
    const { contentType } = contentInfo;
    const textEncoder = new TextEncoder();
    return Object.assign(Object.assign({}, msg), { body: textEncoder.encode(msg.body), contentInfo: Object.assign(Object.assign({}, contentInfo), { contentType: Object.assign(Object.assign({}, contentType), { params: Object.assign(Object.assign({}, contentType.params), { charset: "utf-8" }) }) }) });
};
exports.decodeHttpMessageWithCharset = (_a) => {
    var { contentInfo } = _a, msg = __rest(_a, ["contentInfo"]);
    if (option_1.isNone(contentInfo)) {
        return Object.assign(Object.assign({}, msg), { body: "" });
    }
    else {
        const { charset = "utf-8" } = contentInfo.contentType.params;
        const textDecoder = new TextDecoder(charset);
        const body = textDecoder.decode(msg.body);
        return Object.assign(Object.assign({}, msg), { body });
    }
};
exports.toIOSourceHttpMessage = (_a) => {
    var { body } = _a, msg = __rest(_a, ["body"]);
    return (Object.assign(Object.assign({}, msg), { body: io_1.fromValue()(body) }));
};
