"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const functions_1 = require("@reactive-js/core/lib/functions");
const parserCombinators_1 = require("@reactive-js/core/lib/internal/parserCombinators");
const option_1 = require("@reactive-js/core/lib/option");
exports.entityTagToString = ({ isWeak, tag }) => isWeak ? `\\W"${tag}"` : `"${tag}"`;
const pETagc = parserCombinators_1.satisfy(c => c >= 33 && c <= 256 && c !== 34);
const parseIsWeak = parserCombinators_1.optional(parserCombinators_1.string("W/"));
const parseTag = parserCombinators_1.manySatisfy()(pETagc);
exports.pETag = (charStream) => {
    const isWeak = functions_1.pipe(charStream, parseIsWeak, option_1.isSome);
    parserCombinators_1.pDquote(charStream);
    const tag = parseTag(charStream);
    parserCombinators_1.pDquote(charStream);
    return { isWeak, tag };
};
exports.parseETag = parserCombinators_1.parseWith(exports.pETag);
exports.parseETagOrThrow = parserCombinators_1.parseWithOrThrow(exports.pETag);
