"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const functions_1 = require("@reactive-js/core/lib/functions");
const readonlyArray_1 = require("@reactive-js/core/lib/readonlyArray");
const bannedHeaders = functions_1.pipe([
    "Accept",
    "Accept-Charset",
    "Accept-Encoding",
    "Accept-Language",
    "Cache-Control",
    "Content-Encoding",
    "Content-Length",
    "Content-Type",
    "ETag",
    "Expect",
    "Expires",
    "If-Match",
    "If-None-Match",
    "If-Modified-Since",
    "If-Unmodified-Since",
    "If-Range",
    "Last-Modified",
    "Transfer-Encoding",
    "Vary",
], readonlyArray_1.map(s => s.toLowerCase()));
function getHeaderValue(headers, key) {
    return headers[key.toLowerCase()];
}
exports.getHeaderValue = getHeaderValue;
exports.writeHttpHeaders = (headers, writeHeader) => {
    for (const header in headers) {
        if (headers.hasOwnProperty(header) &&
            !bannedHeaders.includes(header.toLowerCase())) {
            writeHeader(header, headers[header]);
        }
    }
};
exports.filterHeaders = (headers) => {
    const result = {};
    const writeHeader = (k, v) => {
        result[k] = v;
    };
    exports.writeHttpHeaders(headers, writeHeader);
    return result;
};
