import { Function1 } from "@reactive-js/core/lib/functions";
import { ObservableLike } from "@reactive-js/core/lib/observable";
import { HttpResponse, HttpRequest } from "./interfaces";
export declare type HttpServer<THttpRequest extends HttpRequest<unknown>, THttpResponse extends HttpResponse<unknown>> = (req: THttpRequest) => ObservableLike<THttpResponse>;
export declare type HttpRoutedRequest<T> = HttpRequest<T> & {
    readonly params: {
        readonly [param: string]: string;
    };
};
export declare const createRoutingHttpServer: <TReq, TResp>(routes: {
    [path: string]: HttpServer<HttpRoutedRequest<TReq>, HttpResponse<TResp>>;
}, notFoundHandler: Function1<HttpRequest<TReq>, ObservableLike<HttpResponse<TResp>>>) => HttpServer<HttpRequest<TReq>, HttpResponse<TResp>>;
